﻿@model IEnumerable<TooJaVile.Models.Vacation>

@{
    ViewBag.Title = "Calendar";
}

<style>


     table.table-bordered {
        border: 2px solid #de9c6c;
    }

    /*td, th.table-bordered {
        border: 1px solid #de9c6c;
    }


    tr:nth-child(even).table-bordered {
        background-color: lightgray;
    }*/

    .lai {
        width: 400px;
        position: initial;
    }

    .osa {
        position: relative;
        text-align: center;
    }

    .no-margin {
        margin-right: 0px;
        margin-left: 0px;
    }

    .task-no-start-end {
        background-image: linear-gradient(to right, lightblue, blue);
    }

    .task-start-no-end {
        background-image: linear-gradient(to right, blue, lightblue);
    }

    .task-no-start-no-end {
        background-image: linear-gradient(to right, lightblue, blue, lightblue);
    }

    .task-start-end {
        background-image: linear-gradient(to right, blue, lightblue, blue);
    }

    .task-white {
        background-color: transparent;
    }

    .task {
        height: 24px;
        display: inline-block;
    }

    tr.hall {
        background-color: #f7f1f1;
    }

    div.relative {
        position: relative;
        width: 100%;
        height: 20px;
        background-color: transparent;
    }

    div.absolute {
        position: absolute;
        top: 0;
        height: 100%;
        background-color: #de9c6c;
        text-align: center;
    }

    body {
        /*background-image: url('../../Content/3ify0ehu.tqx.jpg');*/
        background-repeat: no-repeat;
        background-attachment: fixed;
        background-size: cover;
    }
   .absolute .staatus {
  visibility: hidden;
  width: 120px;
  background-color: black;
  color: #fff;
  text-align: center;
  border-radius: 6px;
  padding: 5px 0;
  position: absolute;
  z-index: 1;
  
}
    .absolute:hover .staatus {
        visibility: visible;
    }
    
</style>



<h2>Puhkuste kalender</h2>
<h4>Liigu hiirega üle riba, et näha puhkuse detailinfot.</h4>

@*<p>
        @Html.ActionLink("Create New", "Create")
    </p>
    <table class="table">
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.StartDate)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.EndDate)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.VacationState)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.VacationType)
            </th>

            <th>
                @Html.DisplayNameFor(model => model.Person.Email)
            </th>
            <th></th>
        </tr>

        @foreach (var item in Model)
        {
            <tr>
                <td>
                    @Html.DisplayFor(modelItem => item.StartDate)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.EndDate)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.VacationState)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.VacationType)
                </td>

                <td>
                    @Html.DisplayFor(modelItem => item.Person.Email)
                </td>
                <td>
                    @Html.ActionLink("Edit", "Edit", new { id = item.Id }) |
                    @Html.ActionLink("Details", "Details", new { id = item.Id }) |
                    @Html.ActionLink("Delete", "Delete", new { id = item.Id })
                </td>
            </tr>

        }
    </table>*@




@* neid kahte vaatame hiljem, need on et saaks kalendris liikuda *@
@Html.ActionLink("Eelmine", "Calendar", new
{
//month = (ViewBag.Month == 1 ? 12 : (ViewBag.Month - 1)),
year = ViewBag.Year - 1
})
@Html.ActionLink("Järgmine", "Calendar", new
{
year = ViewBag.Year + 1
//month = (ViewBag.Month == 12 ? 1 : (ViewBag.Month + 1)),
//year = (ViewBag.Year ? (ViewBag.Year + 1) : ViewBag.Year)
})

<h3><b>Aasta @ViewBag.Year</b></h3>
@{
    DateTime astart = new DateTime(ViewBag.Year, 1, 1);
    DateTime aend = new DateTime(ViewBag.Year, 12, 31);


}


<table class="table table-bordered" style="background-color:#f7f1f1">
    <thead>
        <tr>
            <td class="col-lg-2" style="color:black"><b>Töötaja</b></td>
            @for (int n = 1; n < 13; n++)
            {
                <th class="col-lg-1">@(new DateTime(2000, n, 1).ToString("MMMM"))</th>
            }
           
        </tr>
    </thead>


    <tbody>
       
       
            @foreach (var itemSuur in Model.GroupBy(x => x.Person.FirstName))
            {
        <tr class="hall">
            <td>@itemSuur.Key</td>
           
            <td colspan="12">

                <div class="relative">
                    @foreach (var item in itemSuur
                                    .Select(x => new
                                    {
                                        tstart = (x.StartDate ?? astart) <= astart ? astart : x.StartDate.Value,
                                        tend = (x.EndDate ?? aend) >= aend ? aend : x.EndDate.Value,
                                        staatus = x.VacationTypeName,
                                        puhkusea = x.StartDate,
                                        puhkusel = x.EndDate,
                                    })

                                    .Select(x => new
                                    {
                                        x.staatus,
                                        x.puhkusea,
                                        x.puhkusel,
                                        algus = (x.tstart - astart).Days * 100 / 365,
                                        pikkus = (x.tend - x.tstart).Days * 100 / 365
                                    }))


                    {
                    <div class="absolute" style="width:@item.pikkus%;left:@item.algus%">
                        <span class="staatus">
                            @item.staatus:
                            @item.puhkusea.Value.ToShortDateString() 
                            -
                            @item.puhkusel.Value.ToShortDateString()

                        </span>
                    </div>
                    }
                </div>
            </td>
        </tr>
            }
            @*foreach (var item in itemSuur)
                {

                    <tr>
                        <td></td>
                        <td colspan="12" class=" no-margin">
                            @{
                                DateTime tstart = (item.StartDate ?? astart) <= astart ? astart : item.StartDate.Value;
                                DateTime tend = (item.EndDate ?? aend) >= aend ? aend : item.EndDate.Value;
                                int algus = (tstart - astart).Days;
                                int kestus = (tend - tstart).Days;
                                string cstart = item.StartDate.HasValue ? " task-start" : " task-no-start";
                                string cend = item.EndDate.HasValue ? "-end" : "-no-end";
                                string cosa = "osa"
                                + ((item.StartDate.HasValue && item.StartDate.Value >= astart) ? " osav" : "")
                                + ((item.EndDate.HasValue && item.EndDate.Value <= aend) ? " osap" : "")
                                ;
                                string citem = cosa + cstart + cend;

                            }
                            <div style="width:@(algus * 100 / 365)%" class="no-margin task task-white"><p></p></div>
                            <div style="width:@(kestus * 100 / 365)%" class=" no-margin task @citem "><p></p></div>
                        </td>
                    </tr>
                }
            }*@
    </tbody>
</table>







